package lainbot

import (
	"strings"

	"github.com/lithammer/fuzzysearch/fuzzy"
	"tuxpa.in/a/irc/pkg/ircv3"
)

type Instance struct {
	Nuh *ircv3.NUH
}

type messageWriter struct {
	mw  ircv3.MessageWriter
	nuh *ircv3.NUH
}

func (messagewriter *messageWriter) WriteMessage(msg *ircv3.Message) error {
	if msg.Command == "PRIVMSG" {
		msg.SetSource(messagewriter.nuh)
	}
	return messagewriter.mw.WriteMessage(msg)
}

func (instance *Instance) Handle(w ircv3.MessageWriter, e *ircv3.Event) {
	instance.handle(&messageWriter{mw: w, nuh: instance.Nuh}, e)
}
func (instance *Instance) handle(w ircv3.MessageWriter, e *ircv3.Event) {
	m := e.Msg
	if m.Command != "PRIVMSG" {
		return
	}
	if m.Param(0) != "#lainmaxxing" {
		return
	}

	messageContent := m.Param(1)
	if strings.HasPrefix(messageContent, "!") {
		instance.handle(w, e)
	}
	if fuzzy.MatchNormalizedFold(messageContent, "let's all love lain") {
		w.WriteMessage(ircv3.NewMessage("PRIVMSG", m.Param(0), "let's all love lain"))
	}
	return
}
func (instance *Instance) handleCommand(w ircv3.MessageWriter, e *ircv3.Event) {
	m := e.Msg
	messageContent := m.Param(1)
	if messageContent == "!ping" {
		w.WriteMessage(ircv3.NewMessage("PRIVMSG", m.Param(0), "pong"))
		return
	}
	return
}
